﻿Imports System.Data.SqlClient
Imports System.Drawing.Printing

Public Class Form1
    Inherits System.Windows.Forms.Form

    <STAThreadAttribute()>
    Public Shared Sub Main()
        Try
            Application.EnableVisualStyles()
        Catch e As Exception
            MessageBox.Show(e.Message & e.StackTrace)
        End Try
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object,
        ByVal e As System.EventArgs) Handles MyBase.Load

        Try
            SetUpForm()
        Catch ex As SqlException
            MessageBox.Show("Errore nell'applicazione! ",
                "ERRORE")
            Application.Exit()
        End Try
    End Sub

    Private Sub SetUpForm()
        Size = New Size(450, 350)
        Dim flowLayout As New FlowLayoutPanel()
        flowLayout.FlowDirection = FlowDirection.TopDown
        flowLayout.Dock = DockStyle.Fill
        Controls.Add(flowLayout)
        Text = "DataGridView columns demo"
    End Sub

    ''' <summary>
    ''' Il controllo Anteprima di Stampa è associato a PrintDocument e quando viene eseguito 
    ''' il rendering dell'anteprima, viene generato l'evento PrintPage. Questo evento viene passato a un
    ''' contesto grafico in cui "disegna" la pagina.
    ''' </summary>
    Private Sub BtnAnteprima_Click(sender As Object, e As EventArgs) Handles BtnAnteprima.Click
        Try
            Dim PrinDocument1 As New PrintDocument()

            ' Orientamento della stampa orizontale impostata su (false).
            PrintDocument1.DefaultPageSettings.Landscape = False

            PrintPreviewDialog1.Document = PrintDocument1
            PrintPreviewDialog1.ShowDialog()

        Catch ex As Exception
            MessageBox.Show("Questo errore è nell'applicazione: " & ex.Message.ToString(), "Attenzione!")
        End Try
    End Sub

    ''' <summary>
    ''' Il controllo Stampa consente all'utente di selezionare la stampante che desidera utilizzare per stampare,
    ''' nonché altre opzioni di stampa.
    ''' </summary>
    Private Sub BtnStampa_Click(sender As Object, e As EventArgs) Handles BtnStampa.Click
        Dim PrinDocument1 As New PrintDocument()

        ' Set the page orientation to landscape(false).
        PrintDocument1.DefaultPageSettings.Landscape = False

        PrintDialog1.Document = PrintDocument1
        If PrintDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            PrintDocument1.Print()
        End If
    End Sub

    Private Sub BtnChiudi_Click(sender As Object, e As EventArgs) Handles BtnChiudi.Click
        Me.Close()
    End Sub

    ''' <summary>
    ''' PrintPage è l'evento di stampa. Questo evento viene generato per ogni
    ''' pagina che verrà stampata. È inoltre possibile gestire gli eventi BeginPrint ed EndPrint
    ''' per ottenere un maggiore controllo.
    ''' </summary>
    Private Sub pdoc_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage

        'Coordinate della stampa dell'immagine.
        Dim margineSuperiore As Integer = CInt(NumericUpDown1.Value)
        Dim margineSinistro As Integer = CInt(NumericUpDown2.Value)
        Dim larghezza As Integer = CInt(NumericUpDown3.Value)
        Dim altezza As Integer = CInt(NumericUpDown4.Value)

        'Se voglio rappresentare l'immagine della PictureBox della Forms di stampa (immagine inserita manualmente nella PictureBox1).
        'uso la seguente riga di codice. 
        ' e.Graphics.DrawImage(PictureBox1.Image, margineSinistro, margineSuperiore, larghezza, altezza)

        'Se voglio rappresentare un'immagine presa in una determinata cartella uso la seguente riga di codice.
        ' e.Graphics.DrawImage(Image.FromFile("C:\Qui va inserito il percorso della cartella dove si trova l'immagine\My.Resources\Immagine.bmp o altro"), margineSinistro, margineSuperiore, larghezza, altezza)

        ' Io per comodità, ho aggiunto una cartella e ci ho messo dentro una immagine e quindi gli ho dato il mio percorso che devi cambiare secondo le tue esigenze.
        e.Graphics.DrawImage(Image.FromFile("C:\EsempioStampa\EsempioStampa\Immagini\Castello.jpg"), margineSinistro, margineSuperiore, larghezza, altezza)
    End Sub

End Class
